package me.hammerle.kp;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import com.destroystokyo.paper.profile.CraftPlayerProfile;
import com.destroystokyo.paper.profile.PlayerProfile;
import com.mojang.authlib.GameProfile;
import com.mojang.authlib.properties.Property;
import org.bukkit.craftbukkit.v1_18_R1.entity.*;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.craftbukkit.v1_18_R1.CraftServer;
import org.bukkit.craftbukkit.v1_18_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_18_R1.block.CraftBlock;
import org.bukkit.craftbukkit.v1_18_R1.event.CraftEventFactory;
import org.bukkit.craftbukkit.v1_18_R1.inventory.CraftItemStack;
import org.bukkit.entity.*;
import org.bukkit.inventory.ItemStack;
import me.hammerle.kp.snuviscript.ScriptEvents;
import net.minecraft.core.BlockPos;
import net.minecraft.core.Registry;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.TagParser;
import net.minecraft.network.protocol.Packet;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.server.network.ServerGamePacketListenerImpl;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.MobCategory;
import net.minecraft.world.entity.PathfinderMob;
import net.minecraft.world.entity.ai.attributes.AttributeSupplier;
import net.minecraft.world.entity.ai.attributes.Attributes;
import net.minecraft.world.entity.ai.attributes.DefaultAttributes;
import net.minecraft.world.entity.ai.goal.FloatGoal;
import net.minecraft.world.entity.ai.goal.LookAtPlayerGoal;
import net.minecraft.world.entity.ai.goal.RandomLookAroundGoal;
import net.minecraft.world.entity.item.ItemEntity;
import net.minecraft.world.entity.monster.Monster;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.phys.Vec3;
import net.minecraft.network.protocol.game.ClientboundAddMobPacket;
import net.minecraft.network.protocol.game.ClientboundPlayerInfoPacket;
import net.minecraft.network.protocol.game.ClientboundAddPlayerPacket;
import net.minecraft.network.protocol.game.ClientboundSetEntityDataPacket;
import net.minecraft.network.protocol.game.ClientboundRemoveEntitiesPacket;

public class NMS {
    private final static HashMap<String, DamageSource> DAMAGE_SOURCES = new HashMap<>();

    private static EntityType<RawHuman.WrapperHuman> HUMAN_TYPE;

    @SuppressWarnings("unchecked")
    public static void init() {
        try {
            Method m = EntityType.class.getDeclaredMethod("a", String.class,
                    EntityType.Builder.class);
            m.setAccessible(true);

            HUMAN_TYPE =
                    (EntityType<RawHuman.WrapperHuman>) m.invoke(null, "human", EntityType.Builder
                            .of(RawHuman.WrapperHuman::new, MobCategory.CREATURE)
                            .sized(0.6f, 1.95f));

            final Field unsafeField = sun.misc.Unsafe.class.getDeclaredField("theUnsafe");
            unsafeField.setAccessible(true);
            final sun.misc.Unsafe unsafe = (sun.misc.Unsafe) unsafeField.get(null);

            Field attributesMapField = DefaultAttributes.class.getDeclaredField("b");
            attributesMapField.setAccessible(true);

            Object base = unsafe.staticFieldBase(attributesMapField);
            long offset = unsafe.staticFieldOffset(attributesMapField);

            Map<EntityType<? extends net.minecraft.world.entity.LivingEntity>, AttributeSupplier> attributesMap =
                    (Map<EntityType<? extends net.minecraft.world.entity.LivingEntity>, AttributeSupplier>) attributesMapField
                            .get(null);
            attributesMap = new HashMap<>(attributesMap);
            attributesMap.put(HUMAN_TYPE,
                    Monster.createMonsterAttributes().add(Attributes.MAX_HEALTH, 20.0)
                            .add(Attributes.ATTACK_DAMAGE, 1)
                            .add(Attributes.MOVEMENT_SPEED, 0.1).add(Attributes.ATTACK_SPEED)
                            .build());

            unsafe.putObject(base, offset, attributesMap);

            DefaultAttributes.validate();
        } catch(Exception ex) {
            ex.printStackTrace();
            KajetansPlugin.warn(ex.getMessage());
        }

        net.minecraft.world.item.ItemStack.maxStackSizeHook = (stack, vanilla) -> {
            return CustomItems.getMaxStackSize(stack.getBukkitStack(), vanilla);
        };
    }

    private static CraftServer getCraftServer() {
        return (CraftServer) Bukkit.getServer();
    }

    public static interface Human extends Creature {
        public void setSkin(String texture, String signature);

        public void setName(String name);
    }

    private static void setId(net.minecraft.world.entity.Entity e, int id) {
        e.setId(id);
    }

    private static int getId(net.minecraft.world.entity.Entity e) {
        return e.getId();
    }

    private static UUID getUUID(net.minecraft.world.entity.Entity e) {
        return e.getUUID();
    }

    private static void moveTo(net.minecraft.world.entity.Entity e, double x, double y, double z,
            float yaw, float pitch) {
        e.moveTo(x, y, z, yaw, pitch);
    }

    private static Level getWorld(net.minecraft.world.entity.Entity e) {
        return e.getLevel();
    }

    private static GameProfile getGameProfile(net.minecraft.world.entity.player.Player e) {
        return e.getGameProfile();
    }

    private static class RawHuman extends CraftCreature implements Human {
        private static class WrapperHuman extends PathfinderMob {
            private ServerPlayer player;

            public WrapperHuman(EntityType<? extends WrapperHuman> type,
                    Level world) {
                super(type, world);
                setPlayer("Default", world);
            }

            private void setPlayer(String name, Level world) {
                player = new ServerPlayer(getCraftServer().getServer(), (ServerLevel) world,
                        new GameProfile(NMS.getUUID(this), name));
                NMS.setId(player, NMS.getId(this));
            }

            @Override
            public void tick() {
                super.tick();
                setYRot(getYHeadRot());
            }

            @Override
            public boolean hurt(DamageSource ds, float amount) {
                if(ScriptEvents.onHumanHurt(ds, getWrappedEntity(), amount)) {
                    return false;
                }
                return super.hurt(ds, amount);
            }

            public RawHuman getWrappedEntity() {
                return new RawHuman(this);
            }

            @Override
            public CraftEntity getBukkitEntity() {
                return getWrappedEntity();
            }

            public ServerPlayer update(ClientboundAddMobPacket p) {
                NMS.setId(player, p.getId());
                NMS.moveTo(player, p.getX(), p.getY(), p.getZ(), 0.0f, 0.0f);
                return player;
            }

            @Override
            public void addAdditionalSaveData(CompoundTag nbt) {
                super.addAdditionalSaveData(nbt);

                GameProfile gp = NMS.getGameProfile(player);
                nbt.putString("HumanName", gp.getName());

                Collection<Property> c = gp.getProperties().get("textures");
                for(Property p : c) {
                    if(p.getName().equals("textures")) {
                        nbt.putString("HumanTexture", p.getValue());
                        nbt.putString("HumanSignature", p.getSignature());
                        break;
                    }
                }
            }

            @Override
            public void readAdditionalSaveData(CompoundTag nbt) {
                super.readAdditionalSaveData(nbt);
                if(nbt.contains("HumanName", CompoundTag.TAG_STRING)) {
                    String name = nbt.getString("HumanName");
                    setPlayer(name, NMS.getWorld(player));
                }
                if(nbt.contains("HumanTexture", CompoundTag.TAG_STRING)
                        && nbt.contains("HumanSignature", CompoundTag.TAG_STRING)) {
                    String texture = nbt.getString("HumanTexture");
                    String signature = nbt.getString("HumanSignature");
                    setSkinWithoutPacket(texture, signature);
                }
            }

            private void updatePosition() {
                Location l = getBukkitEntity().getLocation();
                NMS.moveTo(player, l.getX(), l.getY(), l.getZ(), l.getYaw(), l.getPitch());
            }

            public void setSkinWithoutPacket(String texture, String signature) {
                GameProfile gp = NMS.getGameProfile(player);
                gp.getProperties().clear();
                gp.getProperties().put("textures", new Property("textures", texture, signature));
            }

            private void sync() {
                updatePosition();
                ClientboundPlayerInfoPacket info = new ClientboundPlayerInfoPacket(
                        ClientboundPlayerInfoPacket.Action.ADD_PLAYER, player);
                ClientboundAddPlayerPacket spawn = new ClientboundAddPlayerPacket(player);

                Location center = getBukkitEntity().getLocation();

                for(ServerPlayer p : ((ServerLevel) NMS.getWorld(this)).players()) {
                    double distance = center.distanceSquared(p.getBukkitEntity().getLocation());
                    if(distance < 100.0) {
                        p.connection.send(info);
                        p.connection.send(spawn);
                    }
                }
            }

            public void setSkin(String texture, String signature) {
                setSkinWithoutPacket(texture, signature);
                sync();
            }

            public void setName(String name) {
                setPlayer(name, NMS.getWorld(player));
                sync();
            }

            @Override
            protected void registerGoals() {
                this.goalSelector.addGoal(0, new FloatGoal(this));
                this.goalSelector.addGoal(1,
                        new LookAtPlayerGoal(this, net.minecraft.server.level.ServerPlayer.class,
                                6.0f));
                this.goalSelector.addGoal(2, new RandomLookAroundGoal(this));
            }

            @Override
            public void setDeltaMovement(Vec3 velocity) {}

            @Override
            public void setDeltaMovement(double x, double y, double z) {}
        }

        public final WrapperHuman human;

        private RawHuman(WrapperHuman human) {
            super(getCraftServer(), human);
            this.human = human;
            setPersistent(true);
        }

        private RawHuman(WrapperHuman human, Location l, PlayerProfile profile) {
            this(human);
            NMS.moveTo(human, l.getX(), l.getY(), l.getZ(), l.getYaw(), l.getPitch());
            ((net.minecraft.world.level.LevelWriter) NMS.getWorld(human)).addFreshEntity(human);
        }

        public RawHuman(Location l, PlayerProfile profile) {
            this(HUMAN_TYPE.create(map(l.getWorld())), l, profile);
        }

        public void setSkin(String texture, String signature) {
            human.setSkin(texture, signature);
        }

        public void setName(String name) {
            human.setName(name);
        }
    }

    public static Human createHuman(String name, Location l) {
        return new RawHuman(l, Bukkit.createProfile(UUID.randomUUID(), name));
    }

    private static class PluginConnection extends ServerGamePacketListenerImpl {
        public PluginConnection(ServerGamePacketListenerImpl c) {
            super(getCraftServer().getServer(), c.connection, c.player);
        }

        private RawHuman.WrapperHuman getById(int id) {
            net.minecraft.world.entity.Entity ent = player.getLevel().getEntity(id);
            if(ent instanceof RawHuman.WrapperHuman) {
                return (RawHuman.WrapperHuman) ent;
            }
            return null;
        }

        private boolean handle(ClientboundAddMobPacket p) {
            if(p.getType() != Registry.ENTITY_TYPE.getId(HUMAN_TYPE)) {
                return false;
            }
            UUID uuid = p.getUUID();
            Entity ent = Bukkit.getEntity(uuid);
            if(!(ent instanceof RawHuman)) {
                return false;
            }
            RawHuman raw = (RawHuman) ent;
            ServerPlayer player = raw.human.update(p);
            ClientboundPlayerInfoPacket info = new ClientboundPlayerInfoPacket(
                    ClientboundPlayerInfoPacket.Action.ADD_PLAYER, player);
            ClientboundAddPlayerPacket spawn = new ClientboundAddPlayerPacket(player);

            super.send(info);
            super.send(spawn);
            return true;
        }

        private boolean handle(ClientboundSetEntityDataPacket p) {
            return getById(p.getId()) != null;
        }

        private void handle(ClientboundRemoveEntitiesPacket p) {
            for(int id : p.getEntityIds()) {
                RawHuman.WrapperHuman human = getById(id);
                if(human != null) {
                    ClientboundPlayerInfoPacket remove = new ClientboundPlayerInfoPacket(
                            ClientboundPlayerInfoPacket.Action.REMOVE_PLAYER, human.player);
                    super.send(remove);
                }
            }
        }

        @Override
        public void send(Packet<?> p) {
            if(p instanceof ClientboundAddMobPacket
                    && handle((ClientboundAddMobPacket) p)) {
                return;
            } else if(p instanceof ClientboundSetEntityDataPacket
                    && handle((ClientboundSetEntityDataPacket) p)) {
                return;
            } else if(p instanceof ClientboundRemoveEntitiesPacket) {
                handle((ClientboundRemoveEntitiesPacket) p);
            }
            super.send(p);
        }
    }

    public static void patch(Player p) {
        map(p).connection = new PluginConnection(map(p).connection);
    }

    public static DamageSource getCurrentDamageSource() {
        return CraftEventFactory.currentDamageCause;
    }

    public static Entity getImmediateSource(DamageSource ds) {
        if(ds.getDirectEntity() == null) {
            return null;
        }
        return map(ds.getDirectEntity());
    }

    public static Entity getTrueSource(DamageSource ds) {
        if(ds.getEntity() == null) {
            return null;
        }
        return map(ds.getEntity());
    }

    public static ServerPlayer map(Player p) {
        return ((CraftPlayer) p).getHandle();
    }

    public static net.minecraft.world.item.ItemStack map(ItemStack stack) {
        return CraftItemStack.asNMSCopy(stack);
    }

    public static net.minecraft.world.entity.Entity map(Entity e) {
        return ((CraftEntity) e).getHandle();
    }

    public static Entity map(net.minecraft.world.entity.Entity e) {
        return e.getBukkitEntity();
    }

    public static net.minecraft.world.entity.LivingEntity map(LivingEntity e) {
        return ((CraftLivingEntity) e).getHandle();
    }

    public static net.minecraft.world.entity.projectile.AbstractArrow map(Arrow e) {
        return ((CraftArrow) e).getHandle();
    }

    public static net.minecraft.world.entity.projectile.FireworkRocketEntity map(Firework e) {
        return ((CraftFirework) e).getHandle();
    }

    public static net.minecraft.world.entity.projectile.LargeFireball map(LargeFireball e) {
        return ((CraftLargeFireball) e).getHandle();
    }

    public static net.minecraft.world.entity.projectile.WitherSkull map(WitherSkull e) {
        return ((CraftWitherSkull) e).getHandle();
    }

    public static ItemEntity map(Item e) {
        return (ItemEntity) ((CraftItem) e).getHandle();
    }

    public static ServerLevel map(World e) {
        return ((CraftWorld) e).getHandle();
    }

    public static GameProfile map(PlayerProfile profile) {
        return ((CraftPlayerProfile) profile).getGameProfile();
    }

    public static net.minecraft.world.level.block.state.BlockState map(Block b) {
        return ((CraftBlock) b).getNMS();
    }

    public static DamageSource toDamageSource(Object o) {
        return (DamageSource) o;
    }

    public static DamageSource parseDamageSource(String name) {
        if(DAMAGE_SOURCES.isEmpty()) {
            for(Field f : DamageSource.class.getFields()) {
                if(f.getType() == DamageSource.class) {
                    try {
                        DamageSource ds = (DamageSource) f.get(null);
                        DAMAGE_SOURCES.put(ds.getMsgId(), ds);
                    } catch(Exception ex) {
                    }
                }
            }
        }
        return DAMAGE_SOURCES.get(name);
    }

    public static DamageSource sting(LivingEntity liv) {
        return DamageSource.sting(map(liv));
    }

    public static DamageSource mobAttack(LivingEntity liv) {
        return DamageSource.mobAttack(map(liv));
    }

    public static DamageSource mobIndirect(Entity ent, LivingEntity liv) {
        return DamageSource.indirectMobAttack(map(ent), map(liv));
    }

    public static DamageSource playerAttack(Player p) {
        return DamageSource.playerAttack(map(p));
    }

    public static DamageSource arrow(Arrow arrow, Entity ent) {
        return DamageSource.arrow(map(arrow), map(ent));
    }

    public static DamageSource trident(Entity ent, Entity ent2) {
        return DamageSource.trident(map(ent), map(ent2));
    }

    public static DamageSource firework(Firework firework, Entity ent) {
        return DamageSource.fireworks(map(firework), map(ent));
    }

    public static DamageSource fireball(LargeFireball fireball, Entity ent) {
        return DamageSource.fireball(map(fireball), map(ent));
    }

    public static DamageSource witherSkull(WitherSkull witherSkull, Entity ent) {
        return DamageSource.witherSkull(map(witherSkull), map(ent));
    }

    public static DamageSource projectile(Entity ent, Entity ent2) {
        return DamageSource.thrown(map(ent), map(ent2));
    }

    public static DamageSource indirectMagic(Entity ent, Entity ent2) {
        return DamageSource.indirectMagic(map(ent), map(ent2));
    }

    public static DamageSource thorns(Entity ent) {
        return DamageSource.thorns(map(ent));
    }

    public static DamageSource explosion(LivingEntity liv) {
        return DamageSource.explosion(map(liv));
    }

    public static DamageSource explosionBed() {
        return DamageSource.badRespawnPointExplosion();
    }

    public static void setMessageOfTheDay(String msg) {
        try {
            var server = ((CraftServer) Bukkit.getServer()).getServer();
            server.getClass().getMethod("e", String.class).invoke(server, msg);
        } catch(Exception ex) {
            KajetansPlugin.warn("cannot set motd");
        }
    }

    public static String toString(ItemStack stack) {
        CompoundTag c = new CompoundTag();
        map(stack).save(c);
        return c.toString();
    }

    private static CompoundTag parse(String s) throws Exception {
        return TagParser.parseTag(s);
    }

    public static ItemStack parseItemStack(String stack) throws Exception {
        return CraftItemStack.asCraftMirror(net.minecraft.world.item.ItemStack.of(parse(stack)));
    }

    public static String toString(Entity ent) {
        CompoundTag c = new CompoundTag();
        map(ent).save(c);
        return c.toString();
    }

    public static Entity parseEntity(String stack, Location l) throws Exception {
        CompoundTag c = parse(stack);
        var nmsWorld = map(l.getWorld());
        net.minecraft.world.entity.Entity ent =
                EntityType.loadEntityRecursive(c, nmsWorld, e -> {
                    e.setUUID(UUID.randomUUID());
                    NMS.moveTo(e, l.getX(), l.getY(), l.getZ(), l.getYaw(), l.getPitch());
                    return nmsWorld.addFreshEntity(e) ? e : null;
                });
        return map(ent);
    }

    private static BlockPos convert(Location l) {
        return new BlockPos(l.getBlockX(), l.getBlockY(), l.getBlockZ());
    }

    public static void copyTileEntity(Location from, Location to) {
        var nmsFromWorld = map(from.getWorld());
        var nmsToWorld = map(to.getWorld());

        BlockPos posTo = convert(to);
        BlockEntity fromEntity = nmsFromWorld.getBlockEntity(convert(from));
        BlockEntity toEntity = nmsToWorld.getBlockEntity(posTo);
        if(fromEntity != null && toEntity != null && fromEntity.getClass() == toEntity.getClass()) {
            CompoundTag nbtTagCompound = fromEntity.saveWithFullMetadata();
            toEntity.load(nbtTagCompound);
            Block b = to.getBlock();
            nmsToWorld.sendBlockUpdated(posTo, map(b), map(b), 3);
        }
    }

    public static CompoundTag getBlockEntity(String s) throws Exception {
        return parse(s);
    }

    public static CompoundTag getEntity(Block b) {
        Location l = b.getLocation();
        var nmsWorld = map(l.getWorld());
        BlockEntity te = nmsWorld.getBlockEntity(convert(l));
        if(te == null) {
            return null;
        }
        return te.saveWithoutMetadata();
    }

    public static void setEntity(Block b, CompoundTag nbt) {
        if(nbt == null) {
            return;
        }
        Location l = b.getLocation();
        var nmsWorld = map(l.getWorld());
        BlockPos pos = convert(l);
        BlockEntity te = nmsWorld.getBlockEntity(pos);
        if(te != null) {
            te.load(nbt);
            nmsWorld.sendBlockUpdated(pos, map(b), map(b), 3);
        }
    }

    public static CompoundTag toNBT(Object o) {
        return (CompoundTag) o;
    }
}
